# Exercise - Multi-Knapsack

# DATA
param n;                # Number of items
set N := 1..n;          # Set of items
param k;                # Number of knapsacks
set K := 1..k;          # Set of Knapsacks
param Weight {N};       # Weight of each item
param Value {N};        # Value of each item
param Capacity {K};     # Capacity of each knapsack

# VARIABLES
var x {N,K} binary;		# Assignment variables between items and knapsacks

# CONSTRAINT
# Assignment constraints
subject to Assign {i in N}:
  sum {j in K} x[i,j] <= 1;

# Capacity constraints
subject to Cap_constr {j in K}:
  sum {i in N} Weight[i] * x[i,j] <= Capacity[j];
  
# OBJECTIVE
# Maximize the total value of the selected items
maximize z: sum {i in N} Value[i] * sum {j in K} x[i,j];

##################
data;

param n := 17;
param: Weight   Value :=   
 1		252		20   
 2		250		28   
 3		247		25   
 4		242		19   
 5		228		20   
 6		220		24   
 7		218		19   
 8		199		15   
 9		193		18   
10		181		16   
11		160		14   
12		147		 8   
13		140		 7   
14		130		 5   
15		128		 8   
16		125		 6   
17		120		 8;
 
param k := 2;
param Capacity := 
1 600
2 900;

end;
###########

Cost	   
600		1000	   
900		1500	 