# Exercise - Integer Knapsack

# DATA
param n;
set N := 1..n;
param Weight {N};
param Value {N};
param Capacity;
param Number {N};

# VARIABLES
var x {i in N} integer >=0, <=Number[i];		# Selection variables

# CONSTRAINT
# Capacity constraint
subject to Cap_constr:
  sum {i in N} Weight[i] * x[i] <= Capacity;
  
# OBJECTIVE
# Maximize the total value of the selected items
maximize z: sum {i in N} Value[i] * x[i];

##################
data;
param n := 17;
param: Weight   Value  Number:=   
 1		252		20      10
 2		250		28      10
 3		247		25      10
 4		242		19      10
 5		228		20      10
 6		220		24      10
 7		218		19      10
 8		199		15      10
 9		193		18      10
10		181		16      10
11		160		14      10
12		147		 8      10
13		140		 7      10
14		130		 5      10
15		128		 8      10
16		125		 6      10
17		120		 8      10;
 
param Capacity := 6000;

end;
###########

Cost	   
600		1000	   
900		1500	 