# Exercise - Balanced Knapsack

# DATA
param n;                # Number of items
set N := 1..n;          # Set of items
param Weight {N};       # Weight for each item
param v;                # Number of vehicles
set V := 1..v;          # Set of vehicles

# VARIABLES
var x {N,V} binary;		# Assignment variables
var U;                  # Maximum weight on a vehicle
var L;                  # Minimum weight on a vehicle

# CONSTRAINT
# Assignment constraints
subject to Assign {i in N}:
  sum {j in V} x[i,j] = 1;

# Max weight constraint
subject to Maxweight {j in V}:
  U >= sum {i in N} Weight[i] * x[i,j];
# Min weight constraint
subject to Minweight {j in V}:
  L <= sum {i in N} Weight[i] * x[i,j];

# Symmetry-breaking constraints
#subject to SymmetryBreaking {j in V: j<v}:
#  sum {i in N} Weight[i] * x[i,j] >= sum {i in N} Weight[i] * x[i,j+1];

# OBJECTIVE
# Minimize the max difference in weight between vehicles
minimize z: U - L;

##################
data;
param n := 10;
param v := 5;
param Weight :=
1	 93
2	105
3	 84
4	 63
5	111
6	 90
7	 78
8	120
9	 96
10	 81;
 
end;
###########

Cost	   
600		1000	   
900		1500	 